/*==============================================================================
 * Author:深度训练
 * Create time: 2013-07-08
 * Blog Address:http://www.cnblogs.com/wangiqngpei557/
 * Author Description:特定领域软件工程实践；
 * ==============================================================================*/

namespace Domain.DomainModel.ExaminationModule.Aggregates.EmployeeAgg
{
    using Domain.DomainModel.ApproveModule.Aggregates.ParentMesAgg;
    using Domain.DomainModel.ExaminationModule.Aggregates.EmployeeAgg.EmployeeLogic;
    using Domain.DomainModel.ExaminationModule.Aggregates.EmployeeAgg.EmployeeLogic.PMOperationFactory;
    using Domain.DomainModel.ExaminationModule.Aggregates.FieldExaminationAgg;
    using Domain.Seedwork;
    using System;
    using System.Collections.Generic;

    public partial class Employee : EntityObject
    {
        public Employee()
        {
            this.ParentMessage = new HashSet<ParentMessage>();
            this.TeacherCheckGroup = new HashSet<TeacherCheckGroup>();
        }

        public string EID { get; set; }
        public string EName { get; set; }
        public Nullable<Employee_Marry> IsMarry { get; set; }
        public Nullable<int> Age { get; set; }
        public string UserName { get; set; }
        public string PassWord { get; set; }
        public Nullable<Employee_Switch> SWitch { get; set; }
        public Nullable<Employee_Role> EmpRole { get; set; }
        public Nullable<Employee_Sex> Sex { get; set; }

        public virtual ICollection<ParentMessage> ParentMessage { get; set; }
        public virtual ICollection<TeacherCheckGroup> TeacherCheckGroup { get; set; }

        public void ReSwitch()
        {
            if (this.SWitch.Value == Employee_Switch.IsFalse)
                this.SWitch = Employee_Switch.IsTure;
            else
                this.SWitch = Employee_Switch.IsFalse;
        }

        public void Reinitial()
        {
            PassWord = "000000";
        }

        public IParentMessageOperationFactory OperationFactory { get; set; }
        public void OpeartionParentMessage(ParentMessage pMessage)
        {
            IParentMessageOperation operation = OperationFactory.CreateParentMessageOperation(pMessage.Priority.Value);
            operation.OpeartionMessage(pMessage, this);
        }
    }
}
